function [eigenanalyses]=compression_Jnumrange(uu1,uu2,A,J,Tol,definite,eigenanalyses)

% disp('Subrotine of the main file Jnumrange_main_routine.m');
% disp(' ')
% disp('Programmer: Ana Nata');
% disp('e-mail: anata@ipt.pt')
% disp(' ');
% disp('December 2013')
% disp(' ')
% disp('This subroutine compute the 2x2 compression matrix Ac of A to the subespace')
% disp('Spam{u1,u2} and make the plot the J-numerical range of the compression matrix Ac')

%%
if rank([uu1'; uu2'],10^(-5))==2 
    [u1 u2]=ortog(uu1,uu2,J);
        if definite==0
            norma_1=u1'*J*u1;
            norma_2=u2'*J*u2;
                if isequal(J,eye(size(J,2)))
                    e1=1;
                    e2=1;
                elseif isequal(J,-eye(size(J,2)))
                    e1=-1;
                    e2=-1;
                else
                    if norma_1>0
                        e1=1;
                    else
                        e1=-1;
                    end
                    
                    if norma_2>0
                        e2=1;
                    else
                        e2=-1;
                    end
                end
        else
            if isequal(J,eye(size(J,2)))
                e1=1;
                e2=1;
            elseif isequal(J,-eye(size(J,2)))
                e1=-1;
                e2=-1;
            end
        end
        
    Ac=[]; %Compute the 2x2 compression matrix Ac of A to the subespace Spam{u1,u2}
    Ac(1,1)=e1*u1'*J*A*u1;
    Ac(1,2)=e1*u1'*J*A*u2;
    Ac(2,1)=e2*u2'*J*A*u1;
    Ac(2,2)=e2*u2'*J*A*u2;
    J2=[e1 0; 0 e2];
    [eigenanalyses]=Jnumrange_2x2(Ac,J2,Tol,eigenanalyses); %Plot the J-numerical range of the compression matrix Ac
    hold on
end
