function [eigenanalyses,DD1,DD2,X1,Y1]=regulargrid(A,J,m,Tol,theta1,thetaM,eigenanalyses,definite)

% disp('Subrotine of the main file Jnumrange_main_routine.m');
% disp(' ')
% disp('Programmer: Ana Nata');
% disp('e-mail: anata@ipt.pt')
% disp(' ');
% disp('December 2013')
% disp(' ')
% disp('In this subroutine, the directions theta=theta1+(r-1)*(thetaM-theta1)/m,')
% disp('for r=1,...,m+1, are computed and then the eigenvalues of the')
% disp('J-Hermitian matrix T=Re^J(e^(-itheta)A) with positive and negative')
% disp('J-norm are computed')

%%
DD1=[];DD2=[];UU1=[];UU2=[];X1=[];Y1=[];
    for r=1:m+1
        theta=theta1+(r-1)*(thetaM-theta1)/m;
        T=(exp(-1i*theta)*A+exp(1i*theta)*J*A'*J)/2;    
        [U,D]=eig(T);
        eigenanalyses=eigenanalyses+1;
        D1=[]; D2=[];U1=[];U2=[];
            for s=1:size(U,2)
                u=U(:,s);
                    if abs(real(u'*J*u))>=Tol %no null J-norm
                        if real(u'*J*u)>0 %positive J-norm
                            DD1=[DD1 D(s,s)];
                            UU1=[UU1 U(:,s)];
                            D1=[D1 D(s,s)];
                            U1=[U1 U(:,s)];
                        else
                            DD2=[DD2 D(s,s)];
                            UU2=[UU2 U(:,s)];
                            D2=[D2 D(s,s)];
                            U2=[U2 U(:,s)];
                       end
                    end
            end
            if definite==1
                if isempty(D1)~=1
                    [s1,w1]=sort(real(D1));%sort the elements of D1 in increasing order
                    X1=[X1 U1(:,w1(size(D1,2)))];  %eigenvector associated with the largest eigenvalue
                    Y1=[Y1 U1(:,w1(1))];  %eigenvector associated with the smaller eigenvalue                   
                elseif isempty(D2)~=1
                    [s2,w2]=sort(real(D2));%sort the elements of D2 in increasing order
                    X1=[X1 U1(:,w2(size(D2,2)))]; %eigenvector associated with the largest eigenvalue
                    Y1=[Y1 U1(:,w2(1))]; %eigenvector associated with the smaller eigenvalue
                end
            else
                [s1,w1]=sort(real(D1));%sort the elements of D1 in increasing order
                [s2,w2]=sort(real(D2));%sort the elements of D2 in increasing order
                    if s1(1)>s2(size(D2,2))
                        X1=[X1 U2(:,w2(size(D2,2)))]; %eigenvector associated with the largest eigenvalue in sigma^J-
                        Y1=[Y1 U1(:,w1(1))]; %eigenvector associated with the smaller eigenvalue in sigma^J+
                    else
                        X1=[X1 U2(:,w2(1))]; %eigenvector associated with the smaller eigenvalue in sigma^J-
                        Y1=[Y1 U1(:,w1(size(D1,2)))]; %eigenvector associated with the largest eigenvalue in sigma^J+
                    end     
            end
    end
   
    
    


        
        