function [D1 D2 interla aux]=theta1_e_thetaM(A,J,Tol,theta)

% disp('Subrotine of the main file Jnumrange_main_routine.m');
% disp(' ')
% disp('Programmer: Ana Nata');
% disp('e-mail: anata@ipt.pt')
% disp(' ');
% disp('December 2013')
% disp(' ')
% disp('This subroutine identifies if in the direction theta, the eigenvalues of')
% disp('the J-Hermitian matrix T=Re^J(e^(-itheta)A) are all real, don't interlace')
% disp('and with J-anisotropic eigenvectors')

%%
T=(exp(-1i*theta)*A+exp(1i*theta)*J*A'*J)/2;    
[U D]=eig(T);

count1=0;D1=[];D2=[];
    for s=1:size(U,2)
        u=U(:,s);
        if abs(imag(D(s,s)))<=Tol && abs(real(u'*J*u))>=Tol
           count1=count1+1; %Number of real eigenvalues with J-anisotropic eigenvectors
        end
    end
    if count1==size(A,2)
        aux=1;
    else
        aux=0;
        interla=0;
    end
    
    if aux==1
        for s=1:size(U,2)
            u=U(:,s);
                if abs(real(u'*J*u))>=Tol %no null J-norm
                    if real(u'*J*u)>0 %positive J-norm
                        D1=[D1 D(s,s)];
                    else
                        D2=[D2 D(s,s)];
                    end
                end
        end

        [interla]=interlating(D1,D2,Tol);
    end